create table rr_registrations (
    id              char(36) not null,
    uri             varchar2(512) not null,
    constraint registration_pk primary key (id) 
);

create table rr_kinds (
    id              char(36) not null,
    name            varchar(254) not null unique,
    description     varchar2(1024),
    constraint kinds_pk primary key (id)
);

create table rr_categories (
    id              char(36) not null,
    name            varchar(254) not null unique,
    description     varchar2(1024),
    constraint category_pk primary key (id) 
);

insert into rr_categories values ('83e13247-8728-4e08-9f99-a81f2519b8bd' ,'http://www.ibm.com/category/OptimService', 'http://www.ibm.com/category/OptimService');
insert into rr_categories values('3c29dccf-4234-4c34-a627-bfb37506c995', 'http://www.ibm.com/category/OptimServiceGroup', 'http://www.ibm.com/category/OptimServiceGroup');

create table rr_registration_kind (
    registration_id char(36) not null,
    kind_id         char(36) not null,
    constraint registration_kind_pk primary key (registration_id, kind_id),
    constraint registration_kind_fk1 foreign key (registration_id) references rr_registrations (id),
    constraint registration_kind_fk2 foreign key (kind_id) references rr_kinds (id)
);

create table rr_registration_category (
    registration_id char(36) not null,
    category_id     char(36) not null,
    constraint registration_category_pk primary key (registration_id, category_id),
    constraint registration_category_fk1 foreign key (registration_id) references rr_registrations (id),
    constraint registration_category_fk2 foreign key (category_id) references rr_categories (id)
);

create table rr_content (
    id              char(36) not null,
    name            varchar(254) not null,
    description     varchar2(1024),
    content_type    varchar(128),
    charset_name    varchar(128),
    version_major   int not null,
    version_minor   int not null,
    version_patch   int not null,
    constraint content_pk primary key (id),
    constraint content_name_version unique (name, version_major, version_minor, version_patch)
);

create table rr_content_details (
    id              char(36) not null,
    blob            blob,
    constraint content_details_pk primary key (id),
    constraint content_details_fk foreign key (id) references rr_content(id)
);